package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingVigenciaDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingVigencia;
import com.rjconsultores.ventaboletos.service.GP_PricingVigenciaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingVigenciaService")
public class GP_PricingVigenciaServiceImpl implements GP_PricingVigenciaService {

	@Autowired
	private GP_PricingVigenciaDAO pricingVigenciaDAO;

	public List<GP_PricingVigencia> obtenerTodos() {
		return pricingVigenciaDAO.obtenerTodos();
	}

	public GP_PricingVigencia obtenerID(Integer id) {
		return pricingVigenciaDAO.obtenerID(id);
	}

	@Transactional
	public GP_PricingVigencia suscribir(GP_PricingVigencia entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingVigenciaDAO.suscribir(entidad);
	}

	@Transactional
	public GP_PricingVigencia actualizacion(GP_PricingVigencia entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingVigenciaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(GP_PricingVigencia entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.EXCLUIDO);

		pricingVigenciaDAO.actualizacion(entidad);
	}

	public List<GP_PricingVigencia> buscarPorVigencias(GP_PricingVigencia pv) {
		return pricingVigenciaDAO.buscarPorVigencias(pv);
	}

	public Boolean podeSalvar(GP_Pricing pricing, GP_PricingVigencia pricingVigencia, Date inicio, Date fim) {
		return pricingVigenciaDAO.podeSalvar(pricing, pricingVigencia, inicio, fim);
	}

	@Override
	public List<GP_PricingVigencia> obtenerTodoPorPricing(GP_Pricing pricing) {
		return pricingVigenciaDAO.obtenerTodoPorPricing(pricing);
	}
}
